function pval = approximateDPP_pVal(nodeNum,pairSet,repSize)
%M=NodeNum*(NodeNum-1)/2;
%OR (?)
%"M = the total number of interactions in STRING..."
M=size(pairSet,1);
lambda=0;
for i=1:nodeNum-1
    pool=pairSet(:);
    deg_vi=length(find(pool==i));
    for j=i+1:nodeNum
        deg_vj=length(find(pairSet(:)==j));
        p_ij=1-power(10,(-(deg_vi*deg_vj)/(2*M)));%exp in the paper means 10 as base ?
        if(p_ij>1)
            halt=1
        end
        lambda=lambda+p_ij;
    end
end
%lambda=lambda/2; %no need for this since we go over one triangle only
alpha=0;
for n=0:M%if n>171 breaks due to factorial infinity
    if(isinf(factorial(n)))
        addition_n=realmin('double');%is this OK?
        break;
    else
     exp1=exp(-1*lambda);
     exp2=power(lambda,n);%Problem arrives to inf at n=120 lambda = 386
     if(isinf(exp2))
         exp2=realmax('double');
     end
        addition_n=(exp1*exp2)/factorial(n)
    end
    if(isnan(addition_n) || isinf(addition_n))
        halt=1;
    end
    alpha=alpha+addition_n;
end
pval=0;
for n=repSize:M
     if(isinf(factorial(n)))
        break;
     end
     exp1=exp(-1*lambda);
     exp2=power(lambda,n);%Problem arrives to inf at n=120 lambda=386
     if(isinf(exp2))
         exp2=realmax('double');
     end
    pval=pval+(exp1*exp2)/factorial(n);
    if(isinf(pval))
        halt=1;
    end
end
pval=pval/alpha;