
function  res  = nodesEnrichment( nodeSets,annotations,minRepPerc,threshPval,correctionType,populationSize,h, justAnnotated )
%NODESENRICHMENT Summary of this function goes here
%   Detailed explanation goes here
%setIDs=1;
%if(size(nodeSets,2)==2)
nodeSets=unique(nodeSets,'rows');
    setIDs=unique(nodeSets(:,2));
%end
res=[];
allAnnots=unique(annotations(:,2));
allAnnots(find(allAnnots==0))=[];
allPs=[];
loops=length(setIDs)*size(allAnnots,1);
loop=0;
allAnnotatedNodes=unique(annotations(:,1));
for s=1:length(setIDs)
    sID=setIDs(s);  
    pos=find(squeeze(nodeSets(:,2))==sID);
    setNodes=squeeze(nodeSets(pos,1));
    minRep=minRepPerc*length(setNodes)/100;
    size(allAnnots,1)
    for a=1:size(allAnnots,1)
        loop=loop+1;
        waitbar(0.1+0.8*loop/loops,h)
        annot=allAnnots(a);
        annotPos=find(annotations(:,2)==annot);%find(strcmp(annot,annotations(:,2)));
        annotNodes=squeeze(annotations(annotPos,1));
        annotRepInSet=intersect(annotNodes,setNodes);
        if(length(annotRepInSet)<minRep)
            continue;
        end
        x=length(annotRepInSet);
        k=length(annotNodes);
        
       if(justAnnotated)
            n=length(intersect(setNodes,allAnnotatedNodes));
            m=length(allAnnotatedNodes);%spopulationSize;
        else
            m=populationSize;
            n=length(setNodes);
       end
       
     %  if( n*20<m)
     %    [sID, annot]
     %     p= 1-binocdf(x-1,n,k/m);
     %else
         p=1-hygecdf_(x-1,m,k,n,0);%1-?
         if(p==0)
            p=1-hygecdf_(x-1,m,k,n,10);
         end
         if(p==0)
            p=1-hygecdf_(x-1,m,k,n,20);
         end
    %end
%         if(p==0 && n*20<m)
%             p= 1-binocdf(x-1,m,k/m);
%         end
%         if(p>threshPval)
%             continue;
%         end
        enrch=[];
        enrch.p=p;
        enrch.freqFact=(x/n)/(k/m);
        enrch.set=sID;
        enrch.annot=annot;
        enrch.intersec=annotRepInSet;
        res=[res,enrch];
        allPs=[allPs,p];
    end
end
pos=[];
correctedPs=[];
if(length(allPs)>0 && strcmp(correctionType,'fdr'))
    [~,~,fdr]=fdr_bh(allPs,threshPval);
        pos=find(fdr<=threshPval);
        correctedPs=fdr(pos);
else if (length(allPs)>0 &&strcmp(correctionType,'bonf'))
        allPs=(allPs*length(allPs));
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    else
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    end
end
if(isempty(pos))
    res=[];
else
    res=res(pos);
    for i=1:length(res)
        res(i).correctedP=correctedPs(i);
    end
end
end

