function onResSelected(hObject, eventdata, res,mniCoords,nodeAnnots,colors,annotsConv)  
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: contents = cellstr(get(hObject,'String')) returns contents
% contents{get(hObject,'Value')} returns selected item from listbox1

close(findobj('type','figure','name','Network View'))
%items = get(hObject,'String');
%index_selected = get(hObject,'Value'); 
index_selected = eventdata.Indices; 
% if(index_selected==1)
%     return;
% end
if(isempty(index_selected))
    return;
end
data = get(hObject,'Data');
if(index_selected(1,2)<size(data,2))%only the last column opens the view
    return;
end

resInd=index_selected(1,1);%-1;
items=data(resInd,:);
connections=false;
if(size(res(resInd).intersec,2)>1)
    connections=true;
end
 NET.n=1;
 annotStr= num2str(res(resInd).annot);
 if(~isempty(annotsConv))
     pos1=find(cell2mat(annotsConv(:,1))==res(resInd).annot(1));
     annotStr =   [annotsConv{pos1,2}];
     if(length(res(resInd).annot)>1)
         pos2=find(cell2mat(annotsConv(:,1))==res(resInd).annot(2));
        annotStr =   [annotStr '-' annotsConv{pos2,2}]; 
     end
 end
 NET.title=['Set:' num2str(res(resInd).set) '  Annotation: ' annotStr];
 bgSize=size(mniCoords,1);
 usedNodes=unique(res(resInd).intersec(:));
 elems=size(res(resInd).intersec,1);
      %NET.con_mat=cell(1,2);
     % if(connections)
          NET.con_mat= zeros(length(usedNodes));%(bgSize);
          for elem=1:elems
              node1=res(resInd).intersec(elem,1);
              node2=node1;
              if(connections)
                     node2=res(resInd).intersec(elem,2);
              else
                 node2=node1;
              end
                  NET.con_mat(find(usedNodes==node1),find(usedNodes==node2))=1;
                  %(res(resInd).intersec(elem,1),res(resInd).intersec(elem,2))=1;
%               else
%                   NET.con_mat(res(resInd).intersec(elem),res(resInd).intersec(elem))=1;
%               end
          end
    %  else
     %      NET.con_mat= zeros(2);
   
%end
    
%       [0 0 1 0 0 
%                         0 0 0 1 0
%                         0 0 0 1 0
%                         0 0 0 0 0 
%                         0 0 0 0 0];
%                     NET.con_mat{2}= [0 1 0 0 0 
%                         0 0 0 0 1
%                         0 0 0 0 0
%                         0 0 0 0 0 
%                         0 0 0 0 0];
      NET.node_coor=mniCoords(usedNodes,:);
%       
%       [-20 31 43
%                      -32  52 -11
%                       40  -6  50
%                      -26   0 -18
%                       16 -68  -5];
      NET.node_label=cellstr(num2str( NET.node_coor));%mniCoords));%{};%{'A';'B';'C';'D';'E'};
      pos=[];
      for p=1:length(usedNodes)
          addition=find(nodeAnnots(:,1)==usedNodes(p));
          for a=1:length(addition)
              common=intersect(nodeAnnots(addition(a),2),res(resInd).annot);
              if(length(common)>0)
                  pos=[pos;addition(a)];
              end
          end
         % pos=[pos;find(nodeAnnots(:,1)==usedNodes(p))];
      end
      NET.node_annot=nodeAnnots(pos,:);%TODO make sure that only the relevant annots are colored
      NET.node_annot(:,1)=[1:size(NET.node_annot,1)]';%nodeAnnots(usedNodes,:);
      NET.colors=colors;
   %   NET.test_stat=ones(bgSize);
      NET.pval=res(resInd).correctedP; 
      NET.freqRat=res(resInd).freqFact;
      NET.annotConv=annotsConv;
NetView(NET);

end

