function  res  = pairedEnrichment( pairSets,annotations,minRepPerc,threshPval,correctionType,populationSize,h )
%PAIREDENRICHMENT Summary of this function goes here
%   Detailed explanation goes here  

setIDs=unique(pairSets(:,3));  
res=[];
allAnnots=unique(annotations(:,2));
allPs=[];  
%Generate paired annotations
%pairedAnnotations=[];

% for i=1:populationSize-1
%    % i_pos=find(cell2mat(squeeze(annotations(:,1)))==i);
%    i_pos=find(squeeze(annotations(:,1))==i);
%     i_annots=squeeze(annotations(i_pos,2));
%     for j=i+1:populationSize
%          j_pos=find(squeeze(annotations(:,1))==j);
%          j_annots=squeeze(annotations(j_pos,2));
%          
%         for ai=1:length(i_annots)
%           
%             for aj=1:length(j_annots)
%                 first=min(i_annots(ai),j_annots(aj));
%                   second=max(i_annots(ai),j_annots(aj));
%            %     if(isnumeric(j_annots{aj})&&isnumeric(i_annots{ai}))
% %                   first=num2str(min(i_annots{ai},j_annots{aj}));
% %                   second=num2str(max(i_annots{ai},j_annots{aj}));
%             %    else
%              %       first=char(min(i_annots{ai},j_annots{aj}));
%               %    second=char(max(i_annots{ai},j_annots{aj}));  
%              %   end
%                % pairedAnnotations=[pairedAnnotations;num2cell(i),num2cell(j),cellstr([first,'_' ,second])];
% pairedAnnotations=[pairedAnnotations;i,j,first,second];
%             end
%         end
%     end
% end
     waitbar(0.3,h)  
%allAnnots=unique(pairedAnnotations(:,3:4),'rows');
allNodeAnnots=allAnnots;
if(allNodeAnnots(1)==0)
   allNodeAnnots(1)=[];
end
allAnnots=[];
for i=1:length(allNodeAnnots)
    for j=i:length(allNodeAnnots)
        first=min(allNodeAnnots(i),allNodeAnnots(j));
        second=max(allNodeAnnots(i),allNodeAnnots(j));
        allAnnots=[allAnnots;first,second];
    end
end
%remove=find(allAnnots(:,1).*allAnnots(:,2)==0)
%allAnnots(remove,:)=[];
loop=0%*size(allAnnots,1);
loops=length(setIDs);
for s=1:length(setIDs)
    sID=setIDs(s);%set IDs are assumed to be numerical
    pos=find(pairSets(:,3)==sID);
    setPairs=squeeze(pairSets(pos,1:2));
    for pair=1:size(setPairs,1)
        if(setPairs(pair,1)>setPairs(pair,2))
            tmp=setPairs(pair,1);
            setPairs(pair,1)=setPairs(pair,2);   
             setPairs(pair,2)=tmp;
        end
    end
    minRep=minRepPerc*size(setPairs,1)/100;
    for a=1:size(allAnnots,1)
        loop=loop+1;
            waitbar(0.3+0.6*loop/loops,h)
        annot=allAnnots(a,:);%{a};
        nodesOfFirst=find(annotations(:,2)==annot(1));
        nodesOfSecond=find(annotations(:,2)==annot(2));
        
        numNodes1=length(nodesOfFirst);
        numNodes2=length(nodesOfSecond);
        intersection=length(intersect(nodesOfFirst,nodesOfSecond));
        %annotPos=find((pairedAnnotations(:,3)==annot(1)) .* (pairedAnnotations(:,4)==annot(2)));%find(strcmp(annot,pairedAnnotations(:,3)));
        %Below is the number of pairs between two non disjoint groups:
        annotPairs=(numNodes1-intersection)*(numNodes2-intersection)+intersection*(numNodes1-intersection)+intersection*(numNodes2-intersection)+intersection*(intersection-1)/2;
        %length(nodesOfFirst)*length(nodesOfSecond)-length(intersection);%pairedAnnotations(annotPos,1:2);%cell2mat(squeeze(pairedAnnotations(annotPos,1:2)));%,squeeze(pairedAnnotations(annotPos,2})];
        %annotRepInSet=intersect(annotPairs,setPairs,'rows');
        annotRepInSet=[];
        for pair=1:size(setPairs,1)  
           %TODO count annotRep in set
           annots1=annotations(find(annotations(:,1)==setPairs(pair,1)),2);
           annots2=annotations(find(annotations(:,1)==setPairs(pair,2)),2);
           if(~isempty(find(annots1==annot(1))) && ~isempty(find(annots2==annot(2))))
               annotRepInSet=[annotRepInSet;squeeze(setPairs(pair,:))];%+1;
           else
              if(~isempty(find(annots1==annot(2))) && ~isempty(find(annots2==annot(1))))
                 annotRepInSet=[annotRepInSet;squeeze(setPairs(pair,:))];%annotRepInSet+1;
              end
           end    
        end
        rep=size(annotRepInSet,1);
        cont=rep<minRep
      
        if(cont)
            continue;
        end
        x=rep;%size(annotRepInSet,1);
        k=annotPairs;%size(annotPairs,1);
        n=size(setPairs,1);
        m=populationSize*(populationSize-1)/2;
        
        p=1-hygecdf_(x-1,m,k,n,0);%1-?
        if(p==0)
            p=1-hygecdf_(x-1,m,k,n,10);
        end
        if(p==0)
            p=1-hygecdf_(x-1,m,k,n,20);
        end
%         if(p>threshPval)
%             continue;
%         end
        enrch=[];
        enrch.p=p;
        enrch.freqFact=(x/n)/(k/m);
        enrch.set=sID;
        enrch.annot=annot;
        enrch.intersec=annotRepInSet;
        res=[res,enrch];
        allPs=[allPs,p];
    end
end
if(isempty(res))
    return;
end
    
pos=[];
correctedPs=[];
if(strcmp(correctionType,'fdr'))
    [~,~,fdr]=fdr_bh(allPs,threshPval);
        pos=find(fdr<=threshPval);
        correctedPs=fdr(pos);
else if (strcmp(correctionType,'bonf'))
        allPs=(allPs.*length(allPs));
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    else
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    end
end
if(isempty(pos))
    res=[];
else
    res=res(pos);
    for i=1:length(res)
        res(i).correctedP=correctedPs(i);
    end
end
end

