
%NeiMat=a symmetrical square matrix that contains 1 where an edge exists
function sampledGraph = MCMCSample(graphPairs,perms)
    
    neiMat=zeros(max(graphPairs(:)));
    %'  mcmc start'
    sampledGraph=graphPairs;
    pairCount=size(graphPairs,1);  
    for p=1:pairCount  
        pair=graphPairs(p,:);
        neiMat(min(pair),max(pair))=1;
        %neiMat(graphPairs(p,2),graphPairs(p,1))=1;
    end
    degs_in=sum(neiMat,1)+sum(neiMat,2)';
    
    flips=0;
    
    for i=1:perms
        changeOrder=randint(1,size(graphPairs,1));
        pos2reorder=find(changeOrder);
        sampledGraph(pos2reorder,:)=[sampledGraph(pos2reorder,2),sampledGraph(pos2reorder,1)];

        randPos1=randi(pairCount);
        pos=1:pairCount;
        pos(randPos1)=[];
        randPos2=randi(pairCount-1);
        randPos2=pos(randPos2);
        con1=sampledGraph(randPos1,:);%[sampledGraph(randPos1,1),sampledGraph(randPos1,2)];
        con2=sampledGraph(randPos2,:);%[sampledGraph(randPos2,1),sampledGraph(randPos2,2)];
        if(length(unique([con1,con2]))<4)
            continue;
        end
%         reorder=randint(1,2);
%         if(reorder(1))
%             con1=[con1(2),con1(2)];
%         end
%         if(reorder(2))
%             con2=[con2(2),con2(2)];
%         end
        newCon1=[con1(1),con2(2)];%[sampledGraph(randPos1,1),sampledGraph(randPos2,2)];
        newCon2=[con2(1),con1(2)];%[sampledGraph(randPos2,1),sampledGraph(randPos1,2)];
%         if(newCon1(2)== newCon1(1)|| newCon2(2)== newCon2(1))
%             continue;
%         end
%        neiMatCopy=neiMat;  
        if(neiMat(min(newCon1),max(newCon1)) ==1 ||neiMat(min(newCon2),max(newCon2))==1)
            continue  
        end  
%          if(neiMat(min(con1),max(con1)) ==0 ||neiMat(min(con2),max(con2))==0)
%             continue  
%         end 
    %    a=sum(neiMat(:))
        flips=flips+1;
        neiMat(min(con1),max(con1))=0;
        %neiMat(con1(2),con1(1))=0;
        neiMat(min(con2),max(con2))=0;
       % neiMat(con2(2),con2(1))=0;
        
        neiMat(min(newCon1),max(newCon1))=1;
         %neiMat(newCon1(2),newCon1(1))=1;
          neiMat(min(newCon2),max(newCon2))=1;
          % neiMat(newCon2(2),newCon2(1))=1;  
%           b=sum(neiMat(:))
%           if(b~=a)
%               debug=1;  
%           end
%         
    %   sampledGraph(randPos1,2)=newCon1(2);
       sampledGraph(randPos1,:)=newCon1;
       sampledGraph(randPos2,:)=newCon2;
      % sampledGraph(randPos2,2)=newCon2(2);
       % sampledGraph(randPos2,:)=[min(newCon2),max(newCon2)];
        %findn(triu(neiMat));
        %sampledGraph(randPos1,:)=newCon2;
        %sampledGraph(randPos2,:)=newCon1;
    end
    flips  
  %   '  mcmc end'
  degs_out=sum(neiMat,1)+sum(neiMat,2)';
   degs_diff=degs_out-degs_in;
   if(sum(abs(degs_diff))>0)
       debug1=1;
   end  

end